import 'dart:io';

/**
 * HTTP status messages for dart build in HttpStatus codes
 * https://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html
 */
Map<int, String> httpStatusMessage = {

  HttpStatus.continue_: "Continue",
  HttpStatus.switchingProtocols: "Switching protocols",
  HttpStatus.processing: "Processing",

  HttpStatus.ok: "OK",
  HttpStatus.created: "Created",
  HttpStatus.accepted: "Accepted",
  HttpStatus.nonAuthoritativeInformation: "Non-Authoritative Information",
  HttpStatus.noContent: "No Content",
  HttpStatus.resetContent: "Reset Content",
  HttpStatus.partialContent: "Partial Content",
  HttpStatus.multiStatus: "Multi-Status",
  HttpStatus.alreadyReported: "Already Reported",
  HttpStatus.imUsed: "IM Used",

  HttpStatus.multipleChoices: "Multiple Choices",
  HttpStatus.movedPermanently: "Moved Permanently",
  HttpStatus.found: "Found",
  HttpStatus.seeOther: "See Other",
  HttpStatus.notModified: "Not Modified",
  HttpStatus.useProxy: "Use Proxy",
  HttpStatus.temporaryRedirect: "Temporary Redirect",
  HttpStatus.permanentRedirect: "Permanent Redirect",

  HttpStatus.badRequest: "Bad Request",
  HttpStatus.unauthorized: "Unauthorized",
  HttpStatus.paymentRequired: "Payment Required",
  HttpStatus.forbidden: "Forbidden",
  HttpStatus.notFound: "Not Found",
  HttpStatus.methodNotAllowed: "Method Not Allowed",
  HttpStatus.notAcceptable: "Not Acceptable",
  HttpStatus.proxyAuthenticationRequired: "Proxy Authentication Required",
  HttpStatus.requestTimeout: "Request Timeout",
  HttpStatus.conflict: "Conflict",
  HttpStatus.gone: "Gone",
  HttpStatus.lengthRequired: "Length Required",
  HttpStatus.preconditionFailed: "Precondition Failed",
  HttpStatus.requestEntityTooLarge: "Payload Too Large",
  HttpStatus.requestUriTooLong: "URI Too Long",
  HttpStatus.unsupportedMediaType: "Unsupported Media Type",
  HttpStatus.requestedRangeNotSatisfiable: "Range Not Satisfiable",
  HttpStatus.expectationFailed: "Expectation Failed",
  418: "I'm a Teapot",
  HttpStatus.misdirectedRequest: "Misdirected Request",
  HttpStatus.unprocessableEntity: "Unprocessable Entity",
  HttpStatus.locked: "Locked",
  HttpStatus.failedDependency: "Failed Dependency",
  HttpStatus.upgradeRequired: "Upgrade Required",
  HttpStatus.preconditionRequired: "Precondition Required",
  HttpStatus.tooManyRequests: "Too Many Requests",
  HttpStatus.requestHeaderFieldsTooLarge: "Request Header Fields Too Large",
  HttpStatus.connectionClosedWithoutResponse: "Connection Closed Without Response",
  HttpStatus.unavailableForLegalReasons: "Unavailable For Legal Reasons",
  HttpStatus.clientClosedRequest: "Client Closed Request",

  HttpStatus.internalServerError: "Internal Server Error",
  HttpStatus.notImplemented: "Not Implemented",
  HttpStatus.badGateway: "Bad Gateway",
  HttpStatus.serviceUnavailable: "Service Unavailable",
  HttpStatus.gatewayTimeout: "Gateway Timeout",
  HttpStatus.httpVersionNotSupported: "HTTP Version Not Supported",
  HttpStatus.variantAlsoNegotiates: "Variant Also Negotiates",
  HttpStatus.insufficientStorage: "Insufficient Storage",
  HttpStatus.loopDetected: "Loop Detected",
  HttpStatus.notExtended: "Not Extended",
  HttpStatus.networkAuthenticationRequired: "Network Authentication Required",
  HttpStatus.networkConnectTimeoutError: "Network Connect Timeout Error",
};
